/*
  Copyright (C) 2006-2009 Nasca Octavian Paul
  Author: Nasca Octavian Paul

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License 
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version 2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
*/
#include "Mutex.h"
Mutex::Mutex(){
#ifdef WINDOWS
    InitializeCriticalSection(&mutex);
#else
    pthread_mutex_init(&mutex,NULL);
#endif
};

Mutex::~Mutex(){
#ifdef WINDOWS
    DeleteCriticalSection(&mutex);
#else
    pthread_mutex_destroy(&mutex);
#endif
};


void Mutex::lock(){
#ifdef WINDOWS
    EnterCriticalSection(&mutex);
#else
    pthread_mutex_lock(&mutex);
#endif
};

void Mutex::unlock(){
#ifdef WINDOWS
    LeaveCriticalSection(&mutex);
#else
    pthread_mutex_unlock(&mutex);
#endif
};

